# File Classifier
This scan-level container provides an interface to the [fw-classification toolkit](https://gitlab.com/flywheel-io/scientific-solutions/lib/fw-classification). The toolkit is a library that is capable of classifying CT, MR, PT, and MG datasets based off a declarative set of rules. This container corresponds to the `0.6.5` tag of the [File Classifier](https://gitlab.com/flywheel-io/scientific-solutions/gears/file-classifier/-/tree/0.6.5?ref_type=tags) gear.

### Release notes
**1.1**
- Corresponds to File Classifier Gear v0.6.5
- **Enhancements**:
  - Update classification profiles to v0.4.3
    - adds in CT classification profile
    - updates MR profile to be more robust by using manufacturer-specific and physics based parameters

**1.0**
- Initial release corresponding to File Classifier Gear v0.6.1
---
- [File Classifier](#file-classifier)
    - [Release notes](#release-notes)
    - [Summary](#summary)
    - [Inputs](#inputs)
    - [Configs](#configs)
    - [Custom Classification](#custom-classification)
    - [Classification Workflow](#classification-workflow)
    - [Outputs](#outputs)
      - [Classification Structure](#classification-structure)
        - [CT Structure](#ct-structure)
        - [MR Structure](#mr-structure)
        - [MG Structure](#mg-structure)
        - [PT Structure](#pt-structure)
    - [Cite](#cite)

### Summary
- `File Classifier` supports the following file types:
  - DICOM
    - to classify DICOM, [file-metadata-extractor](https://gitlab.com/flywheel-io/clinical-solutions/XNAT-CS-containers/file-metadata-extractor) container must be run. For DICOMs `File classifier` will look for **file-metadata-extractor/DICOM_header.json**
  - NIFTI
    - to classify NIFTI a JSON sidecar (generated by dcm2niix) must be saved under **/NIFTI**
    - it's assumed that there is only 1 JSON sidecar file. Otherwise the first JSON found under this folder is used.
  - Below is the file structure `File Classifier` expects:
    - <img src="./images/input_fs.png" width=40% />
- When run on a scan, `File Classifier` will automatically try to classify both DICOM and NIFTI
- The container classifies the above metadata with a set of declarative rules, also known as **classification profiles**
  - The container ships with [default classification profiles](https://gitlab.com/flywheel-io/scientific-solutions/lib/fw-classification-profiles/-/tree/0.4.3/classification_profiles):
    - **main.yaml**: the default profile used by the container. This includes the CT, MR, MG, & PT profiles, so the user does not need to specify CT, MR, MG, or PT profile.
  - The profiles are stored under: `/flywheel/v0/fw_gear_file_classifier/classification_profiles/` in the container.
  - If there are custom needs beyond what is included in the default profile see [Custom Classification](#custom-classification).
-  If the container is rerun on a scan, any pre-existing [outputs](#outputs) will be overwritten
- Performance
  - `File Classifier` takes < 1 min to complete, and does not consume much memory since it's acting only on metadata. A default `reserve-memory` of 500 MB was set in the `command.json`.
  - Only 1 CPU is required

### Inputs
- *profile*
  - __Description__: *Classification profile to use*
  - __Type__: String
  - __Default__: `main.yaml`
  - If a custom profile is used, then provide the exact name of the YAML file here, i.e, `myprofile.yaml`. See [Custom Classification](#custom-classification) for more details.

Saved as a project resource:
- *Project level classification*
  - __Description__: *Project level classification*
  - __Type__: JSON
  - See [Custom Classification](#custom-classification) for more details

### Configs
- *debug*
  - __Description__: *Include debug statements in output.*
  - __Type__: Boolean
  - __Default__: `False`

- *validate*
  - __Description__: *Validate classification schema*
  - __Type__: Boolean
  - __Default__: `False`
  - If enabled `File Classifier` will check to see if the modality of the input (determined through the DICOM_header.json or the NIFTI JSON sidecar) is supported by any of the default profiles ([classification profiles](https://gitlab.com/flywheel-io/scientific-solutions/lib/fw-classification-profiles/-/blob/0.4.3/profiles/fw-modality-classification.yaml?ref_type=tags)). If a default profile for the modality is not found, `File Classifier` will not proceed and will exit.


  
### Custom Classification

One can use custom classification profiles in the case that the default profiles (MR, MG, PT) don't cover the use case (i.e, if input dataset is SM modality or you want to add a custom field to the [default classification fields](#classification-structure)).

There are two ways to pass custom classifications in:

1. Create a profile and pass that in through the *profile* input
   - This is a better option if you plan to use the same custom classification on multiple
projects.
   - This should be a YAML file (of any name) that is saved under the project resource. If this is provided `File Classifier` will make an API call to pull it:
     -  <img src="./images/project_rsrc.png" width=30% />
    
      - Let's say that you want to add a key or a field called **CustomFieldName** to the **classification** field **if** *file.type* is *dicom* **and** *file.info.header.dicom.ProtocolName* is *'TheProtocolName'* . The YAML profile would look like this:
  
        ```yaml
        ---
        name: Name of your custom classifier

        # if you want your custom classification to build off of MR.yaml profile, then include it as shown here. 
        # Otherwise this can be excluded from this file.
        includes:
          # Include default MR profile
          - MR.yaml
        ########

        profile:
          - name: set_CustomFieldName
            description: |
              Set custom deleted classification if ProtocolName was deleted
            rules:
              - match_type: 'all'
                match:
                  - key: file.type
                    is: dicom
                  - key: file.info.header.dicom.ProtocolName
                    is: 'TheProtocolName'
                action:
                  - key: file.classification.CustomFieldName
                    add: 'This is the value of the CustomFieldName'
        ```
      
- One can also look at the [classification profiles repo examples](https://gitlab.com/flywheel-io/scientific-solutions/lib/fw-classification-profiles/-/tree/0.4.3/profiles?ref_type=tags) to understand how those profiles are setup to help setup their own custom classification profile.
- [fw-classification toolkit](https://flywheel-io.gitlab.io/scientific-solutions/lib/fw-classification/fw-classification/profile/) docs provides more details on how a YAML profile is constructed.

**NOTE**
- **File Classifier will give an error if one uses their own custom profile ("SM.yaml" that classifies SM, which isn't supported by default), and enables the validate option. In this case it is best to keep validate disabled.**


2. Create a custom classification as a project resource
  - This is a good option if the user doesn't plan on using this custom classification often, or wants to have project-specific classification.
  - In this case, the classification rules are appended to the *profile* being used. So the rules in the *profile* will be processed along with these custom rules.
  - This file must be saved as **classification.json**, otherwise it will not be appended to the classification profile. `File Classifier` will make an API call to pull it.
    -  <img src="./images/project_rsrc.png" width=30% />
  - The same YAML profile seen in option 1 is shown below as **classification.json**:
    ```
    {
        "classifications":[{
          "match": [
              {
                  "key": "file.type",
                  "is": "dicom"
              },
              {
                  "key": "file.info.header.dicom.ProtocolName",
                  "is": "TheProtocolName",
              }

          ],
          "action": [
              {"key": "file.classification.CustomFieldName", "add": "This is the value of the CustomFieldName"}
          ]
      }]
    }
    ```

### Classification Workflow

There are 2 workflows based off the inputs:

Case 1: Default or a custom profile used, with no project level classification.json
- If the default or custom profile is used, and no project level classification.json is found, `File Classifier` will:
  - Find **DICOM_header.json** under **/input/DICOM/file-metadata-extractor**, run the classification, and will save the classification as a scan resource
  - Find a .json file under **/input/NIFTI**, run the classification, and will save the classification as a scan resource

Case 2: Custom project level classification.json exists
  - `File Classifier` will append the rules from classification.json to the profile being used, and then proceed with the DICOM + NIFTI classification as explained above in Case 1.
  


### Outputs
- `File Classifier` will store the classification in a JSON file as a scan resource with the following naming convention: `{file-type}_classification.json`, where **file-type** is **DICOM** or **NIFTI**
  - <img src="./images/output_fs.png" width=40% />




#### Classification Structure

- [fw-modality-classification.yaml](https://gitlab.com/flywheel-io/scientific-solutions/lib/fw-classification-profiles/-/tree/0.4.3/classification_profiles) provides all the possible fields and values that can be populated with the default classification profiles (CT, MR, MG, PT)
- Below are templates of which fields could be populated under the  **classification** key

##### CT Structure
```json
{
  "classification":{
    "Anatomy": [""],
    "Contrast": [""],
    "Contrast Phase": [""],
    "Contrast Delivery": [""],
    "Scan Type": [""],
    "Scan Orientation": [""],
    "Slice Spacing": [""],
    "Convolution Kernel": [""],
    "Phases": [""],
    "Volumetric": [""]
  }
}
```

##### MR Structure
```json
{
  "classification": {
    "Intent": [""],
    "Measurement": [""],
    "Features": [""]
  }
}
```
##### MG Structure
```json
{
  "classification": {
    "Contrast": [""],
    "Laterality": [""],
    "View": [""],
    "Intent": [""],
    "Submodality": [""],
    "Scan Type": [""]
  }
} 
```
##### PT Structure
```json
{
  "classification": {
    "Anatomy": [""],
    "Isotope": [""],
    "Processing": [""],
    "Tracer": [""],
    "Type": [""]
  }
}
```
### Cite
*License: MIT*
